unit ExpDlgF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, StdCtrls, ExtCtrls, VExportDlg, VHTMLExport,
  VRTFExport, VBaseExport;

type
  TfmExpDlg = class(TForm)
    Panel1: TPanel;
    btExport: TButton;
    DataSource1: TDataSource;
    DBGrid: TDBGrid;
    Table1: TTable;
    VExportDialog1: TVExportDialog;
    Label1: TLabel;
    cbTables: TComboBox;
    procedure btExportClick(Sender: TObject);
    procedure VExportDialog1GetHTMLCellParams(Sender: TVHTMLExport;
      Field: TField; var Align: THTMLAlign; AFont: TFont;
      var Background: TColor);
    procedure VExportDialog1GetRTFCellParams(Sender: TVRTFExport;
      Field: TField; var Align: TRTFAlign; AFont: TFont;
      var Background: TColor);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbTablesChange(Sender: TObject);
  private
    { Private declarations }
    procedure FillTables;
  public
    { Public declarations }
  end;

var
  fmExpDlg: TfmExpDlg;

implementation

{$R *.DFM}

procedure TfmExpDlg.btExportClick(Sender: TObject);
begin
  if cbTables.ItemIndex <> -1 then
    VExportDialog1.FileName := ChangeFileExt(cbTables.Text, '')
  else
    VExportDialog1.FileName := 'ExportResult';
  VExportDialog1.Execute();
end;

procedure TfmExpDlg.VExportDialog1GetHTMLCellParams(Sender: TVHTMLExport;
  Field: TField; var Align: THTMLAlign; AFont: TFont; var Background: TColor);
begin
  if Field.FieldName = 'Area' then
    AFont.Color := clRed;
end;

procedure TfmExpDlg.VExportDialog1GetRTFCellParams(Sender: TVRTFExport;
  Field: TField; var Align: TRTFAlign; AFont: TFont;
  var Background: TColor);
begin
  if Field.FieldName = 'Area' then
    AFont.Color := clRed;
end;

procedure TfmExpDlg.FormCreate(Sender: TObject);
begin
  FillTables();
  cbTablesChange(nil);
end;

procedure TfmExpDlg.FormDestroy(Sender: TObject);
begin
  if Table1.Active then
    Table1.Active := False;
end;

procedure TfmExpDlg.FillTables;
begin
  Session.GetTableNames('DBDEMOS', '', True, False, cbTables.Items);
  if cbTables.Items.Count > 0 then
    cbTables.ItemIndex := 0;
end;

procedure TfmExpDlg.cbTablesChange(Sender: TObject);
begin
  if cbTables.ItemIndex <> -1 then begin
    Table1.Active := False;
    Table1.TableName := cbTables.Text;
    Table1.Active := True;
  end;
end;

end.
